# $Revision: 1.13 $, $Date: 2004/09/16 11:47:21 $
#
# Conditional build:
%bcond_without	asmopt	# without assmbler optimization for i586+
#
# disable asmopt where not applicable
%ifarch i386 i486
%undefine	with_asmopt
%endif
%ifnarch %{ix86}
%undefine	with_asmopt
%endif
%define		realname		zlib
Summary:	Library for compression and decompression - Ming32 cross version
Summary(de):	Library fr die Komprimierung und Dekomprimierung
Summary(es):	Biblioteca para compresin y descompresin
Summary(fr):	bibliothque de compression et dcompression
Summary(pl):	Biblioteka z podprogramami do kompresji i dekompresji - wersja skrona dla Ming32
Summary(pt_BR):	Biblioteca para compresso e descompresso
Summary(ru):	    
Summary(tr):	Sktrma ilemleri iin kitaplk
Summary(uk):	̦  Ӧ  Ӧ
Name:		crossmingw32-%{realname}
Version:	1.2.1.1
Release:	2
License:	BSD
Group:		Libraries
#Source0:	http://www.gzip.org/zlib/%{realname}-%{version}.tar.gz
Source0:	http://devel.santafelinux.com/source/%{realname}-%{version}/upstream/tarballs/%{realname}-%{version}.tar.gz
# Source0-md5:	e30f85eed4ecb32841cafe12673c6590
Patch0:		%{realname}-asmopt.patch
Patch1:		%{realname}-infsec.patch
Patch2:		%{name}-shared.patch
URL:		http://www.zlib.org/
BuildRequires:	crossmingw32-gcc
Requires:	crossmingw32-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%define		target			i386-mingw32
%define		arch			%{_prefix}/%{target}

%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++

%ifarch alpha sparc sparc64 sparcv9
%define		optflags	-O2
%endif

%description
The 'zlib' compression library provides in-memory compression and
decompression functions, including integrity checks of the
uncompressed data. This version of the library supports only one
compression method (deflation) but other algorithms may be added later
and will have the same stream interface.

%description -l de
Die zlib-Komprimierungs-Library bietet speicherinterne Komprimierungs-
und Dekomprimierungsfunktionen, einschlielich Integrittsprfungen
der unkomprimierten Daten. Diese Version der Library untersttzt nur
eine Komprimierungsmethode (Deflation), doch knnen weitere
Algorithmen nachtrglich eingefgt werden und haben dann dieselbe
Oberflche.

%description -l es
La biblioteca de compresin 'zlib' nos ofrece funciones de compresin
y descompresin en memoria, incluyendo chequeo de la integridad de
datos no comprimidos. Esta versin de la biblioteca soporta solamente
un mtodo de compresin (deflacin) pero otros algoritmos pueden ser
aadidos ms tarde y tendrn la misma interface. Esta biblioteca se
usa por varios programas de sistema.

%description -l fr
La bibliothque de compression  zlib  offre des fonctions de
compression et de dcompression en mmoire, ainsi qu'une vrification
de l'intgrit des donnes dcompresses. La version de cette
bibliothque ne gre qu'une mthode de compression (deflation), mais
d'autres algorithmes peuvent tre ajouts plus tard et auront la mme
interface.

%description -l pl
Biblioteka zlib udostpnia podprogramy do kompresji i dekompresji w
pamici operacyjnej wcznie ze sprawdzaniem integralnoci w trakcie
dekompresji. Ta wersja biblioteki udostpnia tylko jedn metod
kompresji o nazwie deflation niemniej inne algorytmy mog by
dodawane udostpniajc taki sam interfejs funkcji operujcych na
strumieniu danych.

%description -l pt_BR
A biblioteca de compresso 'zlib' oferece funes de compresso e
descompresso em memria, incluindo checagem da integridade de dados
no comprimidos. Essa verso da biblioteca suporta somente um mtodo
de compresso (deflao) mas outros algoritmos podem ser adicionados
mais tarde e tero a mesma interface. Essa biblioteca  usada por
vrios programas de sistema.

%description -l ru
  zlib     
 ,     . 
      (deflation), 
        ,   
     .

%description -l tr
zlib sktrma kitapl bellekte sktrma ve ama fonksiyonlar
iermektedir. Bu srm yalnzca 'deflation' yntemini
desteklemektedir. Ancak baka algoritmalarn ayn arabirimle
eriilebilecek ekilde eklenme olasl vardr. Bu kitaplk bir dizi
sistem yazlm tarafndan kullanlmaktadr.

%description -l uk
̦ Ӧ zlib ͦ æ Ӧ  Ӧ 
'Ԧ  צ æԦ  .  Ӧ
Цդ Ԧ   Ӧ (deflation),    
ŧ   Φ  ۦ   Ӧ   
    .

%package dll
Summary:	zlib - DLL library for Windows
Summary(pl):	zlib - biblioteka DLL dla Windows
Group:		Applications/Emulators

%description dll
zlib - DLL library for Windows.

%description dll -l pl
zlib - biblioteka DLL dla Windows.

%prep
%setup -q -n %{realname}-%{version}
%patch2 -p1

%if %{with asmopt}
%patch0 -p1
%patch1 -p1
%ifarch i686 athlon
cp contrib/asm686/match.S .
%endif
%ifarch i586
cp contrib/asm586/match.S .
%endif
%endif

# fix for underline test
#sed -e 's/nm/%{target}-nm/' configure > configure.tmp
# but it's broken anyway (tries to use mmap test remains, but there is no mmap
# in mingw32) - so hardcode that underline is needed
sed -e 's/.*grep _hello.*/if false; then/' configure > configure.tmp
mv -f configure.tmp configure
chmod +x configure

%build
CC="%{__cc}" \
CXX="%{__cxx}" \
AR="%{target}-ar rc" \
RANLIB="%{target}-ranlib" \
CFLAGS="-D_REENTRANT %{rpmcflags}%{?with_asmopt: -DASMV}" \
./configure \
	--prefix=%{arch}

%{__make}
%{__make} z.dll

%if 0%{!?debug:1}
%{target}-strip -R.comment -R.note z.dll
%{target}-strip -g -R.comment -R.note *.a
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{arch}{/lib,/include}
install -d $RPM_BUILD_ROOT%{_datadir}/wine/windows/system

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{arch}

install zutil.h $RPM_BUILD_ROOT%{arch}/include
install libz.dll.a $RPM_BUILD_ROOT%{arch}/lib
install z.dll $RPM_BUILD_ROOT%{_datadir}/wine/windows/system

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{arch}/include/*.h
%{arch}/lib/*

%files dll
%defattr(644,root,root,755)
%{_datadir}/wine/windows/system/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: crossmingw32-zlib.spec,v $
Revision 1.13  2004/09/16 11:47:21  wolf
- rel 2 to rebuild with gcc 3.4.2

Revision 1.12  2004/08/30 18:54:03  qboosh
- updated to 1.2.1.1, added infsec patch (fixes CAN-2004-0797)

Revision 1.11  2004/02/28 17:31:12  saq
- more general ix86 %%ifarchs

Revision 1.10  2004/02/21 18:36:40  wolf
- fix alpha, sparc

Revision 1.9  2003/12/25 12:40:54  qboosh
- restored debug support

Revision 1.8  2003/12/25 02:21:16  wolf
- shared lib support

[3:20 wolf@bajzel:~/tmp]% i386-mingw32-gcc example.c -o example.exe -lz
[3:20 wolf@bajzel:~/tmp]% i386-mingw32-strip example.exe
[3:20 wolf@bajzel:~/tmp]% ls -l example.exe
-rwxr-xr-x    1 wolf     wheel       10752 2003-12-25 03:20 example.exe
[3:20 wolf@bajzel:~/tmp]% ./example.exe
zlib version 1.2.1 = 0x1210, compile flags = 0x255
(...)

Revision 1.7  2003/12/01 20:28:34  qboosh
- standard buildroot

Revision 1.6  2003/12/01 19:40:57  qboosh
- strip libz.a

Revision 1.5  2003/11/30 23:45:48  qboosh
- R: crossmingw32-runtime

Revision 1.4  2003/11/30 23:36:52  qboosh
- updated to 1.2.1, fixed build (static-only) and files

Revision 1.3  2003/08/29 23:30:33  ankry
- sync summaries / descriptions; some BR fixed

Revision 1.2  2003/08/27 12:03:28  ggodlewski
- release corrected

Revision 1.1  2003/08/27 12:02:34  ggodlewski
- 1st release
